{
 Engelmann & Schrader GmbH (c) 2006 www.engelmann-schrader.de

 Die Programme dienen ausschliesslich der Information. Es gibt
 weder eine Gewaehrleistung noch wird irgendeine Eigenschaft
 zugesichert. Die Verantwortung fuer den Einsatz von Programm
 bzw. Quelltext liegt vollstaendig beim Anwender.
}
PROGRAM TyStick ;

USES RS232, Stick, Param ;

CONST
  TimeAndDate : TTimeAndDate =
   (Second :    0 ;
    Hour   :   12 ;
    Minute :    5 ;
    Day    :   25 ;
    Month  :    8 ;
    Year   : 2005 ) ;

  Handle = 0 ;

  FileOpenmode = FILEOPENMODE_READONLY ;


PROCEDURE TypeCard ( sourcename:STRING );
VAR
  I             : WORD ;
  C             : BYTE ;
  filelength    : LONGINT ;
  Count         : WORD ;
  ReceiveBuffer : ARRAY [0..511] OF CHAR ;
BEGIN
  IF ( FILEOPEN ( Handle, FileOpenMode, TimeAndDate, sourcename ) ) THEN
    BEGIN

      FILESEEK ( 0, 0, WHENCE_SEEKEND ) ;       (* Get file length *)
      filelength := FILETELL ( 0 )  ;
      FILESEEK ( 0, 0, WHENCE_SEEKSET ) ;

      WHILE filelength > 0 DO
        BEGIN

          IF filelength > 512 THEN              (* *)
            Count := 512
          ELSE
            Count := filelength ;

          filelength := filelength - Count ;
          FILEREAD ( Handle, Count ) ;
          FOR I := 0 TO Count - 1 DO
            ReceiveBuffer [I] := CHAR(getchar) ;

          IF GetResult THEN
            FOR I := 0 TO Count - 1 DO
               WRITE ( ReceiveBuffer[I] ) ;

        END ;
      FILECLOSE ( Handle, TimeAndDate ) ;
    END
  ELSE
    WRITELN ( sourcename, ' not found!' ) ;
END ;

PROCEDURE Help ;
BEGIN
  WRITELN ;
  WRITELN ('USAGE:  TypeS name [/n]') ;
  WRITELN ('Prints the contents of a text file on screen.') ;
  WRITELN ('name:  source filename on usb stick') ;
  WRITELN ('/n:     com interface ( /1 to /4 ) (optional, default is /1)') ;
  WRITELN ;
END ;

BEGIN
  Getparameter ;
  IF ( asourcename <> '' ) THEN
    BEGIN
      RS232.Init ;
      Mount ;
      TypeCard ( asourcename ) ;
      UnMount ;
      RS232.DONE ;
    END
  ELSE
    Help ;
END.



