//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "cspin.h"
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Komponenten, die von der IDE verwaltet werden
    TPanel *Panel1;
    TButton *MOUNTButton;
    TButton *UNMOUNTButton;
    TButton *OPENButton;
    TButton *CLOSEButton;
    TButton *READButton;
    TButton *WRITEButton;
    TButton *FORMATButton;
    TButton *CREATEDIRButton;
    TButton *CHANGEDIRButton;
    TButton *SEEKButton;
    TButton *RENAMEButton;
    TButton *REMOVEButton;
    TButton *WRITEENABLEButton;
    TButton *WRITEDISABLEButton;
    TButton *CONNECTButton;
    TButton *DISCONNECTButton;
    TButton *INITDISPLAYButton;
    TButton *CLEARDISPLAYButton;
    TButton *OPENSERIALButton;
    TListBox *ListBox1;
    TEdit *ParameterEdit1;
    TButton *DIRButton;
    TEdit *ParameterEdit2;
    TCSpinEdit *CSpinEdit1;
    TOpenDialog *OpenDialog1;
    TButton *DISPLAYWRITEButton;
    TButton *DISPLAYOFFButton;
    TButton *BAUDRATEButton;
    TButton *CARDSTATUSButton;
    TEdit *DirectionEdit;
    TButton *DIRECTIONButton;
    TEdit *WriteOutputEdit;
    TButton *WRITEOUTPUTButton;
    TEdit *PullUpEdit;
    TButton *PULLUPButton;
    TEdit *ReadInputEdit;
    TButton *READINPUTButton;
    TButton *DISPLAYONButton;
    TButton *CARDAVAILABLEButton;
    TButton *CARDNOTAVAILABLEButton;
    TGroupBox *GroupBox1;
    TGroupBox *GroupBox2;
    TLabel *Label2;
    TLabel *Label3;
    TGroupBox *GroupBox3;
    TLabel *StatusLabel;
    TLabel *SectorLabel;
    TLabel *PortLabel;
    TGroupBox *GroupBox4;
    TGroupBox *GroupBox5;
    TGroupBox *GroupBox6;
    TButton *TELLButton;
    TButton *FIRMWAREButton;
    TEdit *FirmwareEdit;
    TGroupBox *Filesystem;
    TRadioButton *FileHandleRadioButton1;
    TRadioButton *FileHandleRadioButton2;
    TRadioButton *FileHandleRadioButton3;
    TRadioButton *FileHandleRadioButton4;
    TButton *PingButton;
    void __fastcall OPENSERIALButtonClick(TObject *Sender);
    void __fastcall MOUNTButtonClick(TObject *Sender);
    void __fastcall UNMOUNTButtonClick(TObject *Sender);
    void __fastcall OPENButtonClick(TObject *Sender);
    void __fastcall CLOSEButtonClick(TObject *Sender);
    void __fastcall READButtonClick(TObject *Sender);
    
    void __fastcall SEEKButtonClick(TObject *Sender);
    void __fastcall DIRButtonClick(TObject *Sender);
    
    void __fastcall CHANGEDIRButtonClick(TObject *Sender);
    
    void __fastcall CREATEDIRButtonClick(TObject *Sender);
    void __fastcall RENAMEButtonClick(TObject *Sender);
    void __fastcall REMOVEButtonClick(TObject *Sender);
    void __fastcall FORMATButtonClick(TObject *Sender);
    
    void __fastcall ListBox1DblClick(TObject *Sender);
    
    void __fastcall CSpinEdit1Change(TObject *Sender);
    void __fastcall WRITEButtonClick(TObject *Sender);
    void __fastcall INITDISPLAYButtonClick(TObject *Sender);
    void __fastcall CLEARDISPLAYButtonClick(TObject *Sender);
    void __fastcall DISPLAYWRITEButtonClick(TObject *Sender);
    void __fastcall DISPLAYOFFButtonClick(TObject *Sender);
    void __fastcall CONNECTButtonClick(TObject *Sender);
    void __fastcall DISCONNECTButtonClick(TObject *Sender);
    
    void __fastcall EnableButtons(TObject *Sender);
    void __fastcall DisableButtons(TObject *Sender);
    
    void __fastcall BAUDRATEButtonClick(TObject *Sender);
    
    
    void __fastcall WRITEENABLEButtonClick(TObject *Sender);
    void __fastcall WRITEDISABLEButtonClick(TObject *Sender);
    void __fastcall CARDSTATUSButtonClick(TObject *Sender);
    void __fastcall DIRECTIONButtonClick(TObject *Sender);
    void __fastcall WRITEOUTPUTButtonClick(TObject *Sender);
    void __fastcall PULLUPButtonClick(TObject *Sender);
    void __fastcall READINPUTButtonClick(TObject *Sender);
    
    void __fastcall DISPLAYONButtonClick(TObject *Sender);
    void __fastcall CARDAVAILABLEButtonClick(TObject *Sender);
    void __fastcall CARDNOTAVAILABLEButtonClick(TObject *Sender);
    
    
    
    void __fastcall TELLButtonClick(TObject *Sender);
    
    
    void __fastcall FIRMWAREButtonClick(TObject *Sender);
    void __fastcall FileHandleRadioButton1Click(TObject *Sender);
    
    void __fastcall PingButtonClick(TObject *Sender);
private:	// Benutzerdeklarationen
public:		// Benutzerdeklarationen
    __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
