{
 Engelmann & Schrader GmbH (c) 2006 www.engelmann-schrader.de

 Die Programme dienen ausschliesslich der Information. Es gibt
 weder eine Gewaehrleistung noch wird irgendeine Eigenschaft
 zugesichert. Die Verantwortung fuer den Einsatz von Programm
 bzw. Quelltext liegt vollstaendig beim Anwender.
}
PROGRAM DirS ;

USES RS232, Stick, Misc, Param ;

PROCEDURE Help ;
BEGIN
  WRITELN ;
  WRITELN ('USAGE:  DirS [/n]') ;
  WRITELN ('Displays the current usb stick directory.') ;
  WRITELN ('/n: com interface ( /1 to /4 ) (optional, default is /1)') ;
  WRITELN ;
END ;

PROCEDURE DirCard ;
VAR
  I          : WORD ;
  DirEntry   : ARRAY [0..31] OF BYTE ;
  Filelength : LongInt ;
BEGIN
  Dir ;

  WRITELN ;

  (* reads three bytes and decides if end of directory is reached *)

  FOR I := 0 TO 2 DO
    DirEntry[I] := Getchar   ;

  WHILE DirEntry[0] XOR DirEntry[1] XOR DirEntry[2] <> 0 DO
    BEGIN
      FOR I := 3 TO sizeof ( DirEntry ) - 1 DO
         DirEntry[I] := Getchar  ;

      IF DirEntry[11] <> 15 THEN
        BEGIN

          FOR I := 0 TO 7 DO
            WRITE ( CHAR(DirEntry[I]) ) ;
          WRITE ( ' ' ) ;
          FOR I := 8 TO 10 DO
            WRITE ( CHAR(DirEntry[I]) ) ;

          WRITE (' ', HEX2( Direntry[11]), ' ') ;
          filelength := longint (Direntry[28]) ;
          filelength := filelength + longint (Direntry[29]) * longint    ($100) ;
          filelength := filelength + longint (Direntry[30]) * longint  ($10000) ;
          filelength := filelength + longint (Direntry[31]) * longint($1000000) ;

          WRITE ( filelength:10 ) ;

          WRITELN ;
        END ;
      FOR I := 0 TO 2 DO
        DirEntry[I] := Getchar   ;
    END ;
END ;

BEGIN

  Getparameter ;
  IF ( aParamCount = 0 ) THEN
    BEGIN
      RS232.Init ;
      Mount ;
      DirCard ;
      Unmount ;
      RS232.DONE ;
    END
  ELSE
    Help ;

END .

