{
 Engelmann & Schrader GmbH (c) 2006 www.engelmann-schrader.de

 Die Programme dienen ausschliesslich der Information. Es gibt
 weder eine Gewaehrleistung noch wird irgendeine Eigenschaft
 zugesichert. Die Verantwortung fuer den Einsatz von Programm
 bzw. Quelltext liegt vollstaendig beim Anwender.
}
UNIT Param ;
INTERFACE
VAR
  asourcename   : STRING[80] ;
  atargetname   : STRING[80] ;
  aParamcount   : WORD ;
  acominterface : STRING[2] ;

CONST
  Debug      : BOOLEAN = FALSE ;

  Direction  : BYTE = 0 ;
  FromCard  = 1 ;
  ToCard    = 2 ;


  PROCEDURE GetParameter ;

IMPLEMENTATION

(*

*)
PROCEDURE GetParameter ;
VAR
  aParamStr    : STRING[80] ;
BEGIN
  asourcename   := '' ;
  atargetname   := '' ;
  acominterface := '/1' ;

  aParamcount   := Paramcount ;
  aParamStr     := ParamStr(ParamCount) ;

  WHILE (aParamCount > 0) AND ( aParamStr[1] = '/' ) DO
    BEGIN
      IF aParamStr[2] IN ['1', '2', '3', '4'] THEN
        BEGIN
          acominterface := aParamStr ;
        END
      ELSE IF aParamStr[2] = 'D' THEN
        BEGIN
          DEBUG := TRUE ;
        END ;

      DEC ( aParamcount ) ;
      aParamStr     := ParamStr(aParamCount) ;
    END ;

  IF aParamcount = 1 THEN
    BEGIN
      asourcename := ParamStr(1) ;
      IF (Upcase (asourcename[1]) = 'S') AND (asourcename[2] = ':') THEN
        BEGIN
          Delete ( asourcename, 1 , 2) ;
          atargetname := asourcename ;
          Direction   := FromCard ;
        END ;
    END
  ELSE IF aParamcount = 2 THEN
    BEGIN
      asourcename := ParamStr(1) ;
      atargetname := ParamStr(2) ;
      IF (Upcase (asourcename[1]) = 'S') AND (asourcename[2] = ':') THEN
        BEGIN
          Delete ( asourcename, 1 , 2) ;
          Direction   := FromCard ;
        END
      ELSE IF (Upcase (atargetname[1]) = 'S') AND (atargetname[2] = ':') THEN
        BEGIN
          Delete ( atargetname, 1 , 2) ;
          IF atargetname = '' THEN
            atargetname := asourcename ;
          Direction   := ToCard ;
        END
    END ;

END ;

END.