#include <REG8252.H>

#include "double.h"
#include "serial.h"

extern void resetserial( void ) ;
unsigned char inputbuffer[20] ;

void main ( void ) 
{
 uint8_t MyHandle = 0;

 TimeAndDate_t MyTimeAndDate ;

 MyTimeAndDate.Second  =    0 ;
 MyTimeAndDate.Hour    =   12 ;
 MyTimeAndDate.Minute  =    5 ;
 MyTimeAndDate.Day     =    3 ;
 MyTimeAndDate.Month   =    3 ;
 MyTimeAndDate.Year    = 2006 ;

 EA = 1 ;
 resetserial() ;

 Mount_() ;

 FileOpen_ (MyHandle, "MESSUNG1.TXT", FILEOPENMODE_WRITE, MyTimeAndDate) ;
 FileWrite_(MyHandle, "Daten 01\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 02\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 03\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 04\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 05\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 06\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 07\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 08\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 09\r\n", 1, 10) ;  
 FileWrite_(MyHandle, "Daten 10\r\n", 1, 10) ;  
 FileClose_(MyHandle, MyTimeAndDate) ;

 FileOpen_ (MyHandle, "MESSUNG1.TXT", FILEOPENMODE_APPEND, MyTimeAndDate) ;
 FileSeek_ (MyHandle, 50, WHENCE_SEEKSET );
 FileRead_ (MyHandle, &inputbuffer, 10, 1 ) ;
 FileSeek_ (MyHandle, 50, WHENCE_SEEKSET );
 FileWrite_(MyHandle, "!!!!!!!!\r\n", 1, 10) ;  
 FileClose_(MyHandle, MyTimeAndDate) ;

 UnMount_() ;

 while ( 1 )
  ;

}
